package cn.ibizlab.assetmanagement.core.apply.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyStateModelLine;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplyStateModelLineSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMApplyStateModelLine] 服务对象接口
 */
public interface IEAMApplyStateModelLineService extends IService<EAMApplyStateModelLine>{

    boolean create(EAMApplyStateModelLine et) ;
    void createBatch(List<EAMApplyStateModelLine> list) ;
    boolean update(EAMApplyStateModelLine et) ;
    void updateBatch(List<EAMApplyStateModelLine> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMApplyStateModelLine get(String key) ;
    EAMApplyStateModelLine getDraft(EAMApplyStateModelLine et) ;
    boolean checkKey(EAMApplyStateModelLine et) ;
    boolean save(EAMApplyStateModelLine et) ;
    void saveBatch(List<EAMApplyStateModelLine> list) ;
    Page<EAMApplyStateModelLine> searchDefault(EAMApplyStateModelLineSearchContext context) ;
    List<EAMApplyStateModelLine> selectByEamapplystatemodelid(String eamapplystatemodelid) ;
    void removeByEamapplystatemodelid(String eamapplystatemodelid) ;
    List<EAMApplyStateModelLine> selectByEamapplystateid(String eamapplystateid) ;
    void removeByEamapplystateid(String eamapplystateid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMApplyStateModelLine> getEamapplystatemodellineByIds(List<String> ids) ;
    List<EAMApplyStateModelLine> getEamapplystatemodellineByEntities(List<EAMApplyStateModelLine> entities) ;
}


